(in-namespace "events" :include "common")
(in-context {general})

;;; This file necessarily contains some forward references.
(setq *defer-unknown-connections* t)

(new-type {sensorDevice} {device})
(new-type {recorderDevice} {device})
(new-type {playerDevice} {device})
(new-type {displayerDevice} {device}) ;play vs display
(new-type {actuatorDevice} {device})
(new-type {authenticationDevice} {device})
(new-type {identificationDevice} {device})
(new-type {detectionDevice} {device})
(new-type {recognitionDevice} {device})
(new-type {biometricAuthenticationDevice} {device})
;(new-type-role {offered-service} {device} {service})
;; List of device types already deployed in the context, along with
;; the basic set of services provided by these devices
(new-type {presence sensor} {sensorDevice})
(the-x-of-y-is-z {offered-service} {presence sensor} {presence-detection-service})
(new-type {sound sensor} {sensorDevice})
(the-x-of-y-is-z {offered-service} {sound sensor} {sound-measurement-service})
(new-type {temperature sensor} {sensorDevice})
(the-x-of-y-is-z {offered-service} {temperature sensor} {temperature-measurement-service})
(new-type {light sensor} {sensorDevice})
(the-x-of-y-is-z {offered-service} {light sensor} {light-detection-service})
(new-type {proximity sensor} {sensorDevice})
(the-x-of-y-is-z {offered-service} {proximity sensor} {distance-measurement-service})
(new-type {microphone} {recorderDevice})
(the-x-of-y-is-z {offered-service} {microphone} {audio-capture-service})
(new-type {camera} {recorderDevice})
(new-type {video camera} {camera})
(the-x-of-y-is-z {offered-service} {camera} {image-capture-service})
(the-x-of-y-is-z {offered-service} {camera} {video-capture-service})
(new-type {imagePlayer} {playerDevice})
(the-x-of-y-is-z {offered-service} {imagePlayer} {image-play-service})
(the-x-of-y-is-z {offered-service} {imagePlayer} {video-play-service}) ;more likely, devices that play images, also play videos
(new-type {imageDisplayer} {displayerDevice})
(the-x-of-y-is-z {offered-service} {imageDisplayer} {image-display-service})
(the-x-of-y-is-z {offered-service} {imageDisplayer} {video-display-service}) ;more likely, devices that display images, also display videos (screen)
(new-type {videoPlayer} {playerDevice})
(the-x-of-y-is-z {offered-service}  {videoPlayer} {video-play-service})
(the-x-of-y-is-z {offered-service}  {videoPlayer} {image-play-service})
(new-type {videoDisplayer} {displayerDevice})
(the-x-of-y-is-z {offered-service}  {videoDisplayer} {video-display-service})
(the-x-of-y-is-z {offered-service}  {videoDisplayer} {image-display-service})
(new-type {screen} {displayerDevice})
(the-x-of-y-is-z {offered-service} {screen} {image-display-service})
(the-x-of-y-is-z {offered-service} {screen} {audio-play-service})
(new-type {speaker} {displayerDevice}) ;transport the sound
(the-x-of-y-is-z {offered-service} {speaker}
		   {audio-display-service})
(new-type {audioPlayer} {playerDevice})
(the-x-of-y-is-z {offered-service}  {audioPlayer} {audio-play-service})
(new-type {audioDisplayer} {displayerDevice})
(the-x-of-y-is-z {offered-service}  {audioDisplayer} {audio-display-service})
(new-type {power door lock} {actuatorDevice})
(the-x-of-y-is-z {offered-service} {power door lock} {openning-service})
(the-x-of-y-is-z {offered-service} {power door lock} {closing-service})
(new-type {RFID reader} {authenticationDevice})
(the-x-of-y-is-z {offered-service} {RFID reader} {authentication-service})
(the-x-of-y-is-z {offered-service} {RFID reader} {identification-service})
(new-type {faceRecognitionSystem} {biometricAuthenticationDevice})
(new-is-a {faceRecognitionSystem} {recognitionDevice})
(the-x-of-y-is-z {offered-service} {faceRecognitionSystem} {authentication-service})
(the-x-of-y-is-z {offered-service} {faceRecognitionSystem} {face-recognition-service})
(new-type {faceDetectorSystem} {detectionDevice})
(the-x-of-y-is-z {offered-service} {faceDetectorSystem} {face-detection-service})
(new-type {irisRecognitionSystem} {recognitionDevice})
(new-is-a {irisRecognitionSystem} {biometricAuthenticationDevice})
(the-x-of-y-is-z {offered-service} {irisRecognitionSystem} {iris-recognition-service})
(the-x-of-y-is-z {offered-service} {irisRecognitionSystem} {authentication-service})
(new-type {fingerprintRecognitionSystem} {recognitionDevice})
(new-is-a {fingerprintRecognitionSystem} {biometricAuthenticationDevice})
(the-x-of-y-is-z {offered-service} {fingerprintRecognitionSystem} {fingerprint-recognition-service})
(the-x-of-y-is-z {offered-service} {fingerprintRecognitionSystem} {authentication-service})

;; Roles declaration
(the-x-of-y-is-z {provider-device} {presence-detection-service} {presence sensor})
(the-x-of-y-is-a-z {provider-device} {sound-measurement-service} {sound sensor})
(the-x-of-y-is-a-z {provider-device}  {temperature-measurement-service} {temperature sensor})
(the-x-of-y-is-a-z {provider-device}   {light-detection-service} {light sensor})
(the-x-of-y-is-a-z {provider-device}  {distance-measurement-service}  {proximity sensor})
(the-x-of-y-is-a-z {provider-device}  {image-capture-service} {camera})
(the-x-of-y-is-a-z {provider-device}  {image-display-service} {screen})
(the-x-of-y-is-a-z {provider-device}  {image-display-service} {screen})
(the-x-of-y-is-a-z {provider-device}  {openning-service} {power door lock})
(the-x-of-y-is-a-z {provider-device} {closing-service} {power door lock})
(the-x-of-y-is-a-z {provider-device} {authentication-service} {RFID reader})
(the-x-of-y-is-a-z {provider-device}  {identification-service} {RFID reader}) 

